/////////////////////////////////////////////////////////////////////////////
//                                                                         //
//  dOgger v1.01 - a nifty command line utility for oggenc                 //
//  (c)2001 Tuomo Latto     a.k.a. djv  (djv@mbnet.fi)                     //
//                                                                         //
//  Released under GNU Public License                                      //
//  Please read the attached LICENSE.TXT                                   //
//  If you can not find it run dOgger without parameters.                  //
//  For more information on GPL visit http://www.gnu.org                   //
//                                                                         //
//  Sorry to say this guys, compiling in environment other than Windows    //
//  may need some work. (Especially getch() might need a workaround.)      //
//  This applies to DJGPP, too. So far I've only managed to get E2BIG      //
//  errors. Despite that I'm not planning to develop this program any      //
//  further.                                                               //
//                                                                         //
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
//  I know this code may seem a bit confusing and probably does stuff in   //
//  extremely idiotic way. That's what you get when do these things under  //
//  the infuence of alcohol beverage. Needless to say that I had to do a   //
//  fair amount of debugging and restructuring when I sobered up.          //
/////////////////////////////////////////////////////////////////////////////

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>
#include <io.h>
#include <conio.h>
#include <process.h>
#include <ctype.h>
#include <errno.h>

#ifdef _WIN32
	#define SLASH							'\\'
	#define SLASHSTRING						"\\"
	#define P_WAIT							_P_WAIT
	#define spawnv(mode,cmd,argv)			_spawnv(mode,cmd,argv)
	#define findfirst(filespec,fileinfo)	_findfirst(filespec,fileinfo)
	#define findnext(handle,fileinfo)		_findnext(handle,fileinfo)
	#define findclose(handle)				_findclose(handle)
	#define fixpath( in, out) 				out=_fullpath(NULL,in,0)
	#define chkheap()						_chkheap()
	#define FINDDATA						struct _finddata_t
	#define FNAM							name
	void _chkheap(void){//great for debugging memory corruption
		int heapstatus = _heapchk();
		switch( heapstatus ){
			case _HEAPOK:
				printf( "OK - heap is fine\n" );
				break;
			case _HEAPEMPTY:
				printf( "OK - heap is empty\n" );
				break;
			case _HEAPBADBEGIN:
				printf( "ERROR - bad start of heap\n" );
				break;
			case _HEAPBADNODE:
				printf( "ERROR - bad node in heap\n" );
				break;
		}
	}
#elif __DJGPP__
	#include <dir.h>
	#include <limits.h>
	#include <sys/stat.h>
	#define SLASH							'/'
	#define SLASHSTRING						"/"
	#define findfirst(filespec,fileinfo)	findfirst(filespec,fileinfo,0)
	#define findnext(handle,fileinfo)		findnext(fileinfo)
	#define findclose(handle)				{}
	#define fixpath( in, out) 				out=(char *)malloc(PATH_MAX+1);_fixpath( in, out)
	#define _HEAPOK							0
	#define _HEAPEMPTY						1
	#define _HEAPBADBEGIN					2
	#define _HEAPBADNODE					3
	#define chkheap()						_HEAPOK //DJGPP doesn't support _heapchk()
	#define FINDDATA						struct ffblk
	#define FNAM							ff_name
	void _searchenv( char *filename, char *varname, char *pathname){
		char *path;
		fixpath( searchpath( filename), path);
		strcpy( pathname, path);
		free( path);
	}
#endif

char **errorString=NULL;

void seterrors(void){
	int indx=0;	//	Just to make things a bit easier

	errorString=(char**)malloc( sizeof(char*) * 256);//I didn't want to touch this line unless I absolutely had to...
	errorString[indx++]="Done. %d of %d wav files processed.\n";
	errorString[indx++]="dOgger v1.01  - a nifty command line utility for oggenc that obtains the\n"\
						"                metadata from the wav file name\n"\
						"Copyright (C) 2001  Tuomo Latto     a.k.a.  djv (djv@mbnet.fi)\n"\
						"\n"\
						"Usage:  dOgger <input dir> <output dir> [<bitrate> [<other oggenc params>]]\n"\
						"\n"\
						"        dOgger encodes a batch of wavs to Ogg Vorbis using oggenc. Most of the\n"\
						"        metadata is taken from filenames. It is quite handy with CD rippers.\n"\
						"\n"\
						"        Only the wavs named in the following form are encoded:\n"\
						"                \"<artist> - <album> - TN <track>.wav\"     or\n"\
						"                \" - <album> - TN <artist> - <track>.wav\",\n"\
						"                        where TN is the track number in two-digits.\n"\
						"                Wave files in the latter form produce oggs in the names\n"\
						"                of which the leading separator has been removed.\n"\
						"                Having the separator \" - \" anywhere else in the wav name\n"\
						"                screws things up pretty badly.\n"\
						"\n"\
						"        This program is free software; you can redistribute it and/or\n"\
						"        modify it under the terms of the GNU General Public License\n"\
						"        as published by the Free Software Foundation; either version 2\n"\
						"        of the License, or (at your option) any later version.\n"\
						"\n"\
						"        This program is distributed in the hope that it will be useful,\n"\
						"        but WITHOUT ANY WARRANTY; without even the implied warranty of\n"\
						"        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the\n"\
						"        GNU General Public License for more details.\n"\
						"\n"\
						"        You should have received a copy of the GNU General Public License\n"\
						"        along with this program; if not, write to the Free Software\n"\
						"        Foundation, Inc., 59 Temple Place - Suite 330, Boston,\n"\
						"        MA  02111-1307, USA.  Or visit http://www.gnu.org.\n";
	errorString[indx++]="No input files found. Run dOgger without parameters for help.\n";
	errorString[indx++]="oggenc error %d.\n";
	errorString[indx++]="oggenc could not be found.\n";
	///-5-/// spawn/oggenc errors
	errorString[indx++]="Argument list too long.\n";
	errorString[indx++]="EINVAL - invalid mode in spawnv. Blame the last person to modify the source.\n";
	errorString[indx++]="oggenc not found - location changed.\n";
	errorString[indx++]="oggenc not executable.\n";
	errorString[indx++]="Not enough mem to execute oggenc.\n";
	errorString[indx++]="oggenc error %d\n";
	errorString[indx]=NULL;
}

void showhelp(){
	int count=0;
	unsigned int a;
	int c;
	char askforcontinue[]="--- Press any key to continue   or  'q' to quit ---";
	
	for(a=0; a<strlen( errorString[1]); a++){
		putchar( c=errorString[1][a]);
		if(c == '\n')
			if( !(++count%18)){
				printf( askforcontinue);
				while(!kbhit());
				c=getch();
				if(c=='q' || c=='Q') exit(1);
				else putchar('\n');};
	};
	exit(1);

}

void quit(int errnumber, int arg1, int arg2){
	if(!arg1 && !arg2) fprintf( stderr, errorString[ errnumber]);				//no args
	else if(!arg2 && arg1) fprintf( stderr, errorString[ errnumber], arg1);		//1 arg
	else fprintf( stderr, errorString[ errnumber], arg1, arg2);					//2 args
	exit(errnumber);
}

int _isubstring(char *string, char *sub){
	unsigned int a;
	for(a=0; a<=strlen( string) - strlen( sub); a++)
		if(!strnicmp( &string[a], sub, strlen( sub))) return a;
	return strlen( string);
}

char *artist=NULL;
char *album=NULL;
char *tracknumber=NULL;
char *trackname=NULL;
char *bitrate=NULL;
char **additionalparams=NULL;
unsigned int additionalparamcount=0;
char *separator=NULL;
char **oggencargs=NULL;
char *inpath, *outpath;

int invalidwavfile(char *filename){
	unsigned int a;
	unsigned int b=3;
	
	a=_isubstring( filename, separator);
	if(!a){//" - <album> - TN <artist> - <track>"
		a=b + _isubstring( &filename[b], separator);
		if(a >= strlen(filename) - 4) return 0x02;
		strncpy( album, &filename[b], a - b);
		album[a - b]='\0';
		
		a+=3;
		strncpy( tracknumber, &filename[a], 3);
		tracknumber[3]='\0';
		if(!isdigit( filename[a]) || !isdigit( filename[a+1])
			|| filename[a+2]!=' ' || strlen( filename) < a+7)// 3+4
					return 0x03;
		
		b=a+3;
		a=b + _isubstring( &filename[b], separator);
		if(a >= strlen(filename) - 4) return 0x04;
		strncpy( artist, &filename[b], a - b);
		artist[a - b]='\0';
		
		b=a+3;
		a=b + _isubstring( &filename[b], ".wav");
		if(a > strlen(filename) - 4) return 0x05;
		strncpy( trackname, &filename[b], a - b);
		trackname[a - b]='\0';
		
		//output file	"<path>%l - %n %a - %t.ogg"
		oggencargs[12]=(char *)malloc( strlen(outpath) + 22);
		strcpy( oggencargs[12], "\"");
		strcat( oggencargs[12], outpath);
		strcat( oggencargs[12], "%l - %n %a - %t.ogg\"");
		
		//input file
		if(oggencargs[13 + additionalparamcount] == NULL) free(oggencargs[13 + additionalparamcount]);
		oggencargs[13 + additionalparamcount]=(char *)
			malloc( strlen(inpath) + strlen(artist) + strlen(album) + strlen(trackname) + 19);
		strcpy( oggencargs[13 + additionalparamcount], "\"");
		strcat( oggencargs[13 + additionalparamcount], inpath);
		strcat( oggencargs[13 + additionalparamcount], " - ");
		strcat( oggencargs[13 + additionalparamcount], album);
		strcat( oggencargs[13 + additionalparamcount], " - ");
		strcat( oggencargs[13 + additionalparamcount], tracknumber);
		strcat( oggencargs[13 + additionalparamcount], artist);
		strcat( oggencargs[13 + additionalparamcount], " - ");
		strcat( oggencargs[13 + additionalparamcount], trackname);
		strcat( oggencargs[13 + additionalparamcount], ".wav\"");
	}
	else if(a >= strlen(filename) - 4) return 1;
	else{//"<artist> - <album> - TN <track>"
		strncpy( artist, filename, a);
		artist[a]='\0';
		
		b=a+3;
		a=b + _isubstring( &filename[b], separator);
		if(a >= strlen(filename) - 4) return 0x12;
		strncpy( album, &filename[b], a - b);
		album[a - b]='\0';
		
		a+=3;
		strncpy( tracknumber, &filename[a], 3);
		tracknumber[3]='\0';
		if(!isdigit(filename[a]) || !isdigit(filename[a+1])
				|| filename[a+2]!=' ' || strlen(filename) - 4 < a+3)
			return 0x13;
		
		b=a+3;
		a=b + _isubstring( &filename[b], ".wav");
		if(a > strlen(filename) - 4) return 0x14;
		strncpy( trackname, &filename[b], a - b);
		trackname[a - b]='\0';
		
		//output file	"<path>%a - %l - %n %t.ogg"
		oggencargs[12]=(char *)malloc( strlen(outpath) + 22);
		strcpy( oggencargs[12], "\"");
		strcat( oggencargs[12], outpath);
		strcat( oggencargs[12], "%a - %l - %n %t.ogg\"");
		
		//input file
		if(oggencargs[13 + additionalparamcount] == NULL) free(oggencargs[13 + additionalparamcount]);
		oggencargs[13 + additionalparamcount]=(char *)
			malloc( strlen(inpath) + strlen(artist) + strlen(album) + strlen(trackname) + 16);
		strcpy( oggencargs[13 + additionalparamcount], "\"");
		strcat( oggencargs[13 + additionalparamcount], inpath);
		strcat( oggencargs[13 + additionalparamcount], artist);
		strcat( oggencargs[13 + additionalparamcount], " - ");
		strcat( oggencargs[13 + additionalparamcount], album);
		strcat( oggencargs[13 + additionalparamcount], " - ");
		strcat( oggencargs[13 + additionalparamcount], tracknumber);
		strcat( oggencargs[13 + additionalparamcount], trackname);
		strcat( oggencargs[13 + additionalparamcount], ".wav\"");
	};
	// oggenc		-b 192				-a <artist>			-l <album>		-t <track>
	//				-N <tracknumber>	-n <output file>	[<params>]		<infile>
	if(oggencargs[4] == NULL) free(oggencargs[4]);
	oggencargs[4]=(char *)malloc( strlen( artist) + 3);
	strcpy( oggencargs[4], "\"");
	strcat( oggencargs[4], artist);
	strcat( oggencargs[4], "\"");
	
	if(oggencargs[6] == NULL) free(oggencargs[6]);
	oggencargs[6]=(char *)malloc( strlen( album) + 3);
	strcpy( oggencargs[6], "\"");
	strcat( oggencargs[6], album);
	strcat( oggencargs[6], "\"");
	
	if(oggencargs[8] == NULL) free(oggencargs[8]);
	oggencargs[8]=(char *)malloc( strlen( trackname) + 3);
	strcpy( oggencargs[8], "\"");
	strcat( oggencargs[8], trackname);
	strcat( oggencargs[8], "\"");
	strcpy( oggencargs[10], tracknumber);
	return 0;
}

void setupstaticparams(){
	unsigned int a;
	// oggenc		-b 192				-a <artist>			-l <album>		-t <track>
	//				-N <tracknumber>	-n <output file>	[<params>]		<infile>
	
	oggencargs[0]=(char *)malloc( 514);//this should do it...
	_searchenv( "oggenc.exe", "PATH", oggencargs[0]);
	if( !strlen( oggencargs[0])) quit(4, 0, 0);
	oggencargs[1]=(char *)malloc( 3);
	strcpy( oggencargs[1], "-b");
	
	oggencargs[2]=(char *)malloc( 4);
	strcpy( oggencargs[2], bitrate);
	oggencargs[3]=(char *)malloc( 3);
	strcpy( oggencargs[3], "-a");

	oggencargs[5]=(char *)malloc( 3);
	strcpy( oggencargs[5], "-l");
	oggencargs[7]=(char *)malloc( 3);
	strcpy( oggencargs[7], "-t");
	
	oggencargs[9]=(char *)malloc( 3);
	strcpy( oggencargs[9], "-N");
	oggencargs[10]=(char *)malloc( 4);
	
	oggencargs[11]=(char*)malloc( 3);
	strcpy( oggencargs[11], "-n");
	
	for(a=0; a<additionalparamcount; a++){
		oggencargs[13 + a]=(char *)malloc( strlen( additionalparams[a]) + 1);
		strcpy(oggencargs[13 + a], additionalparams[a]);};
	oggencargs[14 + additionalparamcount]=NULL;
}

int main(int argc, char *argv[]){
	
	int a, retval;
	unsigned int b;
	char *infilespec;
	long filehandle=-1;
	FINDDATA *fdata;
	int filecount;
	int totalnumberofwavfiles=0;
	char **filenames;
	
	bitrate=(char *) malloc( 4);
	separator=(char *) malloc( 4);
	strcpy( bitrate, "192");
	strcpy( separator, " - ");
	
	tracknumber=(char *)malloc( 4);
	//These should be enough...
	album=(char *)malloc( 256);
	artist=(char *)malloc( 256);
	trackname=(char *)malloc( 256);
	
	seterrors();
	fdata=(FINDDATA *)malloc( sizeof(FINDDATA));
	
	if(argc < 3) showhelp();
	else if(argc > 3){
		free( bitrate);
		bitrate=argv[3];
		if(argc > 5){
			additionalparams=&argv[4];
			additionalparamcount=argc - 4;};};
	
	oggencargs=(char **)malloc( (15 + additionalparamcount) * sizeof(char*));
	setupstaticparams();
	
	fixpath(argv[2], outpath);
	if( outpath[ strlen(outpath) - 1] != SLASH){
		outpath=(char *)realloc( outpath, strlen( outpath) + 2);
		strcat( outpath, SLASHSTRING);};
	fixpath(argv[1], inpath);
	if( inpath[ strlen(inpath) - 1] != SLASH){
		inpath=(char *)realloc( inpath, strlen( inpath) + 2);
		strcat( inpath, SLASHSTRING);};
	
	infilespec=(char *)malloc( strlen( inpath) + 6);
	
	strcpy( infilespec, inpath);
	strcat( infilespec, "*.wav");
	
	filehandle=findfirst( infilespec, fdata);
	if(filehandle == -1) quit(2, 0, 0);
	filenames=(char **)malloc( sizeof(char *));//to justify realloc()
	
	do{
		fprintf( stderr, "%s found\n", fdata->FNAM);
		filenames=(char **) realloc(
			filenames, sizeof(char*) * (totalnumberofwavfiles + 1)); //+1 should do it
		filenames[ totalnumberofwavfiles]=(char *)malloc( strlen( fdata->FNAM) + 1);
		strcpy( filenames[ totalnumberofwavfiles++ ], fdata->FNAM);
	}while(!findnext( filehandle, fdata));
	
	findclose(filehandle);
	errno=0;//so it won't fuck up our routines later (_findnext sets it)
	fprintf( stderr, "%d wav files found.\n", totalnumberofwavfiles);
	
	for(a=filecount=0; a<totalnumberofwavfiles; a++){
		retval=invalidwavfile( filenames[a]);
		if(!retval){
			fprintf( stderr, "\n\nFile %d / %d:\n", ++filecount, totalnumberofwavfiles);
			retval=spawnv( P_WAIT, oggencargs[0], oggencargs);
			if(errno == E2BIG)	fprintf( stderr, errorString[5]);
			if(errno == EINVAL) quit(6,0,0);
			if(errno == ENOENT) quit(7,0,0);
			if(errno == ENOEXEC)quit(8,0,0);
			if(errno == ENOMEM) quit(9,0,0);
			if(retval == -1)	quit(3, filecount, totalnumberofwavfiles);
			else if(retval)		fprintf( stderr, errorString[10], retval);
		};
	};
	
	//This is not obligatory, or wouldn't be with DJGPP,
	//but who knows about these M$ compilers...
	if(album) free(album);
	if(artist) free(artist);
	if(inpath) free(inpath);
	if(bitrate) free(bitrate);
	if(outpath) free(outpath);
	if(separator) free(separator);
	if(trackname) free(trackname);
	if(infilespec) free(infilespec);
	if(tracknumber) free(tracknumber);
	for(b=0; b<14 + additionalparamcount; b++) free( oggencargs[b]);
	free(oggencargs);
	
	chkheap();
	quit(0, filecount, totalnumberofwavfiles);
	return 0;
}
